#lang racket
(require rackunit)
(provide subst count-occurrences)

; --------------------------------------------------------------------------
; VERSION 2: subst                                        (mutual recursion)
; --------------------------------------------------------------------------

(define subst
  (lambda (new old slist) 
    (if (null? slist)
        '()
        (cons (subst-symbol-expr new old (first slist)) ;; break into parts;
              (subst new old (rest slist))) )))         ;; solve; re-assemble

;(define subst-symbol-expr
;  (lambda (new old symexp)
;    (if (symbol? symexp)
;        ;; handle a symbol
;        ;; handle an slist
;        )
;    ))

;(define subst-symbol-expr
;  (lambda (new old symexp) 
;    (if (symbol? symexp)
;        (if (eq? symexp old)
;            new
;            symexp)
;        ;; handle an slist
;        )
;    ))

(define subst-symbol-expr
  (lambda (new old symexp) 
    (if (symbol? symexp)
        (if (eq? symexp old)
            new
            symexp)
        (subst new old symexp) )))

(check-equal? (subst 'd 'b '(a b c a b c d))
              '(a d c a d c d))
(check-equal? (subst 'a 'b '((a b) (((b g r) (f r)) c (d e)) b))
              '((a a) (((a g r) (f r)) c (d e)) a))

; --------------------------------------------------------------------------
; EXERCISE 2: count-occurrences                           (mutual recursion)
; --------------------------------------------------------------------------

;(define count-occurrences
;  (lambda (s slist)
;    (if (null? slist)
;        ;; slist is empty
;        ;; slist is a cons
;        )
;    ))

(define count-occurrences
  (lambda (s slist)
    (if (null? slist)
        0                                                ;; slst is empty
        (+ (count-occurrences-sym-expr s (first slist))  ;; slst is a cons
           (count-occurrences s (rest slist))) )))       ;;   solve and add

;(define count-occurrences-sym-expr
;  (lambda (s sym-expr)
;    (if (symbol? sym-expr)
;        ;; sym-expr is a symbol
;        ;; sym-expr is an slist
;        )
;    ))

(define count-occurrences-sym-expr
  (lambda (s sym-expr)
    (if (symbol? sym-expr)
        (if (eq? s sym-expr) 1 0)            ;; sym-expr is a symbol
        (count-occurrences s sym-expr) )))   ;; sym-expr is an slist

(check-equal? (count-occurrences 'a '(a b c))
              1)
(check-equal? (count-occurrences 'a
                 '(((a be) a ((si be a) be (a be))) (be g (a si be))))
              5)

; --------------------------------------------------------------------------
